<?xml version="1.0"?>
<!-- 
	XSLT transform for Correlator Debugger pages.
	$Copyright(c) 2009-2010, 2012 Progress Software Corporation (PSC). All rights reserved.$ 
	$Copyright (c) 2013-2014, 2017 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$ 
	Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG 
-->
<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   version="1.0"
   >
  <xsl:output method="html" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" />

  <xsl:template match="map[@name='apama-response']">
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
      <head>
        <title>Apama</title>
        <link rel="stylesheet" type="text/css" href="/resources/apama.css" />
        <link rel="stylesheet" type="text/css" href="/resources/profiler.css" />
        <script language="javascript" type="text/javascript" src="/resources/javascript-split.js">
          <xsl:comment></xsl:comment>
        </script>
        <script language="javascript" type="text/javascript" src="/resources/xhr_props.js">
          <xsl:comment></xsl:comment>
        </script>
        <script language="javascript" type="text/javascript" src="/resources/methods.js">
          <xsl:comment></xsl:comment>
        </script>
        <script language="javascript" type="text/javascript" src="/resources/profiler.js">
          <xsl:comment></xsl:comment>
        </script>
        <script language="javascript" type="text/javascript" src="/resources/jquery.js">
          <xsl:comment></xsl:comment>
        </script>
        <script language="javascript" type="text/javascript" src="/resources/jquery.csv.js">
          <xsl:comment></xsl:comment>
        </script>
        <script language="javascript" type="text/javascript" src="/resources/jquery.dataTables.js">
          <xsl:comment></xsl:comment>
        </script>
        <script language="javascript" type="text/javascript" src="/resources/debugger.js">
          <xsl:comment></xsl:comment>
        </script>
        <script language="javascript" type="text/javascript" src="/resources/edit_area_full.gz">
          <xsl:comment></xsl:comment>
        </script>
      </head>
      <body>        
		<div class='masthead'><img src="/resources/images/product_logo.png" alt="Apama" /></div>
		<div class='content'>
			<div id="componentName">
				<script language="javascript">getComponentInfo(document.location);</script>
			</div>
			<xsl:apply-templates select="*"/>
		</div>
		<div class="footer"><span class="footer-txt">Copyright (c) 2020 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.</span><img src="/resources/images/sag-footer.png" alt="Logo" /></div>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="prop[@name='profilingdata']">
    <div id='profilingdata_div'>
      <input type='button' value='Get Profile' onclick='loadprofile();' id='profiling_data_id'/>
      <table id='profilingdata' class='tableApamaResponse'></table>
    </div>
    <hr/>
  </xsl:template>

  <xsl:template match="prop[@name='memorydata']">
    <div id='memorydata_div'>
      <input type='button' value='Get Memory Stats' onclick='loadmemory();' id='load_memory_id'/>
      <table id='memorydata1' class='tableApamaResponse'></table>
      <table id='memorydata2' class='tableApamaResponse'></table>
    </div>
    <hr/>
  </xsl:template>

  <xsl:template match="list[@name='senders']|list[@name='receivers']">
    <table class='tableApamaResponse'>
      <thead>
        <tr>
          <th colspan="3">
			 <xsl:value-of select="translate(substring(@name,1,1),'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
            <xsl:value-of select="substring(@name, 2)"/>
          </th>
        </tr>
        <tr>
          <th>Name</th>
          <th>Details</th>
          <th>Disconnect</th>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select="map">
          <tr>
            <xsl:if test="position() mod 2 = 1">
              <xsl:attribute name="class">alt</xsl:attribute>
            </xsl:if>
            <td>
              <xsl:value-of select="@name" />
            </td>
            <td>
              <xsl:apply-templates select="." />
            </td>
            <td>
              <input type='button' value='Disconnect'>
                <xsl:attribute name='onclick'>
                  putProperty("/connections/<xsl:value-of select="prop[@name='physicalId']/text()" />:<xsl:value-of select="prop[@name='logicalId']/text()" />/<xsl:value-of select="substring(../@name, 0, string-length(../@name))" />", "reason", "Disconnect requested via web interface")
                </xsl:attribute>                
				<xsl:attribute name='id'>disconnect_<xsl:value-of select="substring(../@name, 0, string-length(../@name))" />_id</xsl:attribute>
              </input>
            </td>
          </tr>
        </xsl:for-each>
      </tbody>
    </table>
  </xsl:template>

  <xsl:template match="prop[@name='epltypes']">
    <h3>EPL Types</h3>
    <p>This page lists all event types that the correlator is aware of</p>
    <script language="javascript" type="text/javascript">
      function ealoadcallback(id) { }
      makeEditor("codeView", false);
    </script>
    <textarea id="codeView" style='width: 100%;' rows="24">
      <xsl:value-of select="." />
    </textarea>
  </xsl:template>

  <xsl:template match="list[@name='senders']//list|list[@name='receivers']//list|list[@name='senders']//map|list[@name='receivers']//map">
    <xsl:if test="count(*) >= 1">
      <table class="tableApamaResponse">
        <thead>
          <tr>
            <th>Name</th>
            <th>Value</th>
          </tr>
        </thead>
        <tbody>
          <xsl:for-each select="*">
            <tr>
              <xsl:if test="position() mod 2 = 1">
                <xsl:attribute name="class">alt</xsl:attribute>
              </xsl:if>
              <td>
                <xsl:value-of select="@name" />
              </td>
              <td>
                <xsl:apply-templates select="." />
              </td>
            </tr>
          </xsl:for-each>
        </tbody>
      </table>
    </xsl:if>
  </xsl:template>
  <xsl:template match="prop">
    <xsl:value-of select="text()" />
  </xsl:template>

  <xsl:template match="prop[@name='title']">
    <h2>
      <xsl:value-of select="." />
    </h2>
  </xsl:template>

  <xsl:template match="list">
    <table class='tableApamaResponse'>
      <thead>
        <tr>
          <th colspan="3">
            <xsl:value-of select="@name" />
          </th>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select="map">
          <tr>
            <xsl:if test="position() mod 2 = 1">
              <xsl:attribute name="class">alt</xsl:attribute>
            </xsl:if>
            <td>
              <xsl:value-of select="prop[@name='description']/text()" />
            </td>

            <xsl:choose>

              <xsl:when test="@name = 'action'">
                <td colspan='2' style='text-align: center'>
                  <input type='button'>
                    <xsl:attribute name='id'>profiler_<xsl:value-of select="prop[@name='verb']/text()" />_id</xsl:attribute>
                    <xsl:attribute name='value'>
						<xsl:value-of select="translate(substring(prop[@name='verb']/text(),1,1),'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
						<xsl:value-of select="substring(prop[@name='verb']/text(), 2)"/>
                    </xsl:attribute>
                    <xsl:attribute name='onclick'>
                      <xsl:choose>
                        <xsl:when test="prop[@name='payload']">
                          <xsl:value-of select="prop[@name='method']/text()" />("<xsl:value-of select="prop[@name='path']/text()" />", "<xsl:value-of select="prop[@name='payload']/text()" />")
                        </xsl:when>
                        <xsl:otherwise>
                          <xsl:value-of select="prop[@name='method']/text()" />("<xsl:value-of select="prop[@name='path']/text()" />")
                        </xsl:otherwise>
                      </xsl:choose>
                    </xsl:attribute>
                  </input>
                </td>
              </xsl:when>

              <xsl:when test="@name = 'input'">
                <td>
                  <input type='text'>
                    <xsl:attribute name='name'>
                      <xsl:value-of select="prop[@name='id']/text()" />
                    </xsl:attribute>
                  </input>
                </td>
                <td>
                  <input type='button' id='dbpbutton' value="Submit">
                    <xsl:attribute name='onclick'>
                      submit("<xsl:value-of select="prop[@name='id']/text()" />",
                      "<xsl:value-of select="prop[@name='action']/text()" />")
                    </xsl:attribute>
                  </input>
                </td>
              </xsl:when>

            </xsl:choose>

          </tr>
        </xsl:for-each>
      </tbody>
    </table>
    <hr/>
  </xsl:template>

  <xsl:template match="*">
    <xsl:apply-templates select="*"/>
  </xsl:template>

</xsl:stylesheet>

